import React, { useState } from 'react';
import { Icon } from '../Icon';
import { Popover } from '../Popover';
import { Bar, Indicator, ProgressBarContainer, ProgressValue, ProgressWrapper, IndicatorStatusWrapper, } from './styles';
function prepareProgressValue(value, total) {
    return Math.round((Number(value) / Number(total)) * 100) || 0;
}
export var ProgressBar = function (_a) {
    var indicator = _a.indicator, popover = _a.popover, total = _a.total, current = _a.current, label = _a.label, staticIcon = _a.staticIcon, indicatorStatusIcon = _a.indicatorStatusIcon, _b = _a.indicatorStatusIconColor, indicatorStatusIconColor = _b === void 0 ? 'primary' : _b, wrapperWidth = _a.wrapperWidth;
    var _c = useState(null), anchorEl = _c[0], setAnchorEl = _c[1];
    var popoverOpen = Boolean(anchorEl);
    var progress = prepareProgressValue(current, total);
    function handleMouseOverIcon(event) {
        setAnchorEl(event.currentTarget);
    }
    function handleMouseLeaveIcon() {
        setAnchorEl(null);
    }
    return (React.createElement(ProgressWrapper, { width: wrapperWidth },
        React.createElement(ProgressValue, null,
            current,
            "/",
            total,
            " ",
            label),
        React.createElement(ProgressBarContainer, null,
            progress < 100 && React.createElement(Bar, { progress: 100 }),
            progress > 0 && React.createElement(Bar, { progress: progress, active: true }),
            indicator && (React.createElement(Indicator, null,
                React.createElement(Icon, { name: indicator, regular: !staticIcon && popoverOpen, fitted: true, size: "large", bordered: true, circular: true, onMouseOver: handleMouseOverIcon, onMouseLeave: handleMouseLeaveIcon }),
                indicatorStatusIcon && (React.createElement(IndicatorStatusWrapper, null,
                    React.createElement(Icon, { name: indicatorStatusIcon, fitted: true, size: "mini", inverted: true, circular: true, color: indicatorStatusIconColor })))))),
        popover && (React.createElement(Popover, { offset: -8, placing: "top", anchorElement: anchorEl, isOpen: popoverOpen }, popover))));
};
